"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function MutationPayloadQueryPlugin(builder) {
  builder.hook("GraphQLObjectType:fields", function (fields, _ref, _ref2) {
    var $$isQuery = _ref.$$isQuery,
        extend = _ref.extend,
        getTypeByName = _ref.getTypeByName;
    var isMutationPayload = _ref2.scope.isMutationPayload;

    if (!isMutationPayload) {
      return fields;
    }
    var Query = getTypeByName("Query");
    return extend(fields, {
      query: {
        description: "Our root query field type. Allows us to run any query from our mutation payload.",
        type: Query,
        resolve() {
          return $$isQuery;
        }
      }
    });
  });
};
//# sourceMappingURL=MutationPayloadQueryPlugin.js.map